package net.asukaze.cassava.core.model;

import java.nio.charset.Charset;

public interface ICassavaTableModel {
	public void clear();

	public void deleteCellsLeft(int rowIndex, int columnIndex, int deleteRows,
			int deleteColumns);

	public void deleteColumn(int columnIndex);

	public void deleteRow(int rowIndex);

	public String getCalculatedValueAt(int rowIndex, int columnIndex);

	public CellCalculator getCellCalculator();

	public Charset getCharset();

	public int getColumnCount();

	public int getColumnCount(int rowIndex);

	public DataFormat getDataFormat();

	public String getFilename();

	public String getLineSeparator();

	public int getRowCount();

	public String getValueAt(int rowIndex, int columnIndex);

	public void insertCellsRight(int rowIndex, int columnIndex, int insertRows,
			int insertColumns);

	public void insertColumn(int columnIndex);

	public void insertRow(int rowIndex);

	public boolean isModified();

	public void setCellCalculator(CellCalculator cellCalculator);

	public void setCharset(Charset charset);

	public void setColumnCount(int columnCount);

	public void setDataFormat(DataFormat dataFormat);

	public void setFilename(String filename);

	public void setLineSeparator(String lineSeparator);

	public void setModified(boolean modified);

	public void setRowCount(int rowCount);

	public void setValueAt(Object value, int rowIndex, int columnIndex);
}