package net.asukaze.cassava.core.model;

public class Selection {
	public int left;
	public int top;
	public int right;
	public int bottom;

	public Selection(int left, int top, int right, int bottom) {
		this.left = Math.min(left, right);
		this.top = Math.min(top, bottom);
		this.right = Math.max(left, right);
		this.bottom = Math.max(top, bottom);
	}

	public boolean isSelected(int x, int y) {
		return (x >= left && x <= right && y >= top && y <= bottom);
	}

	public boolean isOneCellSelected() {
		return (left == right && top == bottom);
	}

	public static Selection create(int currentCol, int currentRow) {
		return new Selection(currentCol, currentRow, currentCol, currentRow);
	}
}
