package net.asukaze.cassava.core.util;

import static org.junit.Assert.*;

import org.junit.Test;

public class ValueUtilTest {
	@Test
	public void testIsNumber() {
		assertFalse(ValueUtil.isNumber(""));
		for (int i = -10; i <= 10; i++) {
			assertTrue(ValueUtil.isNumber(Integer.toString(i)));
		}
		for (double d = -2; d < 2; d += 0.0625) {
			assertTrue(ValueUtil.isNumber(Double.toString(d)));
		}
		assertTrue(ValueUtil.isNumber("+123.456E+78"));
		assertTrue(ValueUtil.isNumber("+123.456E78"));
		assertTrue(ValueUtil.isNumber("+123.456E-78"));
		assertTrue(ValueUtil.isNumber("-123.456e+78"));
		assertTrue(ValueUtil.isNumber("-123.456e78"));
		assertTrue(ValueUtil.isNumber("-123.456e-78"));
		assertTrue(ValueUtil.isNumber("2E3"));
		assertTrue(ValueUtil.isNumber("."));
		assertTrue(ValueUtil.isNumber("-."));
		assertTrue(ValueUtil.isNumber(".5"));
		assertTrue(ValueUtil.isNumber("   .   "));
		assertFalse(ValueUtil.isNumber("ABC"));
		assertFalse(ValueUtil.isNumber(" "));
		assertFalse(ValueUtil.isNumber("+-123"));
		assertFalse(ValueUtil.isNumber("123.456+78"));
		assertFalse(ValueUtil.isNumber("123.456E7.8"));
		assertFalse(ValueUtil.isNumber("123.456E+-7.8"));
		assertFalse(ValueUtil.isNumber("2Ee3"));
		assertFalse(ValueUtil.isNumber("-E4"));
	}
}
