package net.asukaze.cassava.encoding.command;

import net.asukaze.cassava.core.model.ICassavaTableModel;
import net.asukaze.cassava.core.model.Selection;

public class TransformKZCommand extends TransformCommand {
	public TransformKZCommand(ICassavaTableModel model, Selection selection) {
		super(model, selection);
	}

	private char transform(char c) {
		if (c == ' ') {
			return '@';
		} else if (c < '' || c > '') {
			return c;
		} else if (c >= '' && c <= '') {
			return (char) ('A' + (c - '') * 2);
		} else if (c >= '' && c <= '') {
			return (char) ('J' + (c - '') * 2);
		} else if (c >= '' && c <= '') {
			return (char) ('c' + (c - '') * 2);
		} else if (c >= '' && c <= '') {
			return (char) ('i' + (c - ''));
		} else if (c >= '' && c <= '') {
			return (char) ('n' + (c - '') * 3);
		} else if (c >= '' && c <= '') {
			return (char) ('}' + (c - ''));
		} else if (c >= '' && c <= '') {
			return (char) ('' + (c - '') * 2);
		} else if (c >= '' && c <= '') {
			return (char) ('' + (c - ''));
		} else if (c == '') {
			return '';
		} else if (c == '') {
			return '';
		} else if (c == '') {
			return '';
		} else if (c >= '' && c <= '') {
			return (char) ('@' + (c - '') * 2);
		} else if (c >= '' && c <= '') {
			return (char) ('' + (c - '') * 2);
		} else if (c == '') {
			return 'b';
		} else if (c == '') {
			return '[';
		} else if (c == '') {
			return 'J';
		} else if (c == '') {
			return 'K';
		} else if (c == '') {
			return 'B';
		} else if (c == '') {
			return 'u';
		} else if (c == '') {
			return 'v';
		} else if (c == '') {
			return 'A';
		} else if (c == '') {
			return 'E';
		} else {
			return c;
		}
	}

	@Override
	protected String transform(String value) {
		char[] arr = value.toCharArray();
		StringBuilder sb = new StringBuilder();
		for (int i = 0; i < arr.length; i++) {
			char h = arr[i];
			char z = transform(h);
			if (i < arr.length - 1) {
				switch (arr[i + 1]) {
				case '':
					if ((h >= '' && h <= '') || (h >= '' && h <= '')) {
						z++;
						i++;
					} else if (h == '') {
						z = '';
						i++;
					}
					break;
				case '':
					if (h >= '' && h <= '') {
						z += 2;
						i++;
					}
				}
			}
			sb.append(z);
		}
		return sb.toString();
	}
}
