package net.asukaze.cassava.ui;

import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.io.File;
import java.io.IOException;
import java.util.List;

import javax.swing.TransferHandler;

import net.asukaze.cassava.ui.Log;

@SuppressWarnings("serial")
public abstract class FileDropHandler extends TransferHandler {
	public abstract void fileDropped(File file) throws IOException;

	@Override
	public boolean canImport(TransferSupport support) {
		if (!support.isDrop()) {
			return false;
		}
		return support.isDataFlavorSupported(DataFlavor.javaFileListFlavor);
	}

	@Override
	public boolean importData(TransferSupport support) {
		if (!canImport(support)) {
			return false;
		}

		try {
			Object data = support.getTransferable().getTransferData(
					DataFlavor.javaFileListFlavor);
			List<?> fileList = (List<?>) data;
			for (Object file : fileList) {
				if (file instanceof File) {
					fileDropped((File) file);
				}
			}
			return true;
		} catch (UnsupportedFlavorException ex) {
			Log.error(ex);
			return false;
		} catch (IOException ex) {
			Log.error(ex);
			return false;
		}
	}
}
