package net.asukaze.cassava.ui;

import java.util.MissingResourceException;
import java.util.ResourceBundle;

public class Messages {
	public static final String CASSAVA_TITLE = "CASSAVA_TITLE"; //$NON-NLS-1$
	public static final String OPTION_DIALOG_TITLE = "OPTION_DIALOG_TITLE"; //$NON-NLS-1$
	public static final String ERROR_TITLE = "ERROR_TITLE"; //$NON-NLS-1$
	public static final String ACTION_NOT_FOUND = "ACTION_NOT_FOUND"; //$NON-NLS-1$
	public static final String OPEN_DIALOG_TITLE = "OPEN_DIALOG_TITLE"; //$NON-NLS-1$
	public static final String PASTE_DIALOG_OPTION_N = "PASTE_DIALOG_OPTION_"; //$NON-NLS-1$
	public static final String PASTE_DIALOG_TITLE = "PASTE_DIALOG_TITLE"; //$NON-NLS-1$
	public static final String PASTE_DIALOG_MESSAGE = "PASTE_DIALOG_MESSAGE"; //$NON-NLS-1$
	public static final String PASTE_OPTION_NORMAL = "PASTE_OPTION_NORMAL"; //$NON-NLS-1$
	public static final String SAVE_DIALOG_TITLE = "SAVE_DIALOG_TITLE";//$NON-NLS-1$
	public static final String SAVE_DIALOG_DEFAULT = "SAVE_DIALOG_DEFAULT";//$NON-NLS-1$

	private static final String BUNDLE_NAME = "net.asukaze.cassava.ui.messages"; //$NON-NLS-1$
	private static final ResourceBundle RESOURCE_BUNDLE = ResourceBundle
			.getBundle(BUNDLE_NAME);

	private Messages() {
	}

	public static String getString(String key) {
		try {
			return RESOURCE_BUNDLE.getString(key);
		} catch (MissingResourceException e) {
			return '!' + key + '!';
		}
	}

	public static String getString(String key, Object... args) {
		try {
			return String.format(RESOURCE_BUNDLE.getString(key), args);
		} catch (MissingResourceException e) {
			return '!' + key + '!';
		}
	}
}
