package net.asukaze.cassava.ui.action;

import javax.swing.JTextArea;
import javax.swing.table.TableCellEditor;

import net.asukaze.cassava.core.command.Command;
import net.asukaze.cassava.core.model.DataFormat;
import net.asukaze.cassava.io.command.CopyCommand;
import net.asukaze.cassava.io.command.CopyCommand.Type;
import net.asukaze.cassava.ui.table.CassavaGrid;
import net.asukaze.cassava.ui.table.CassavaTableCellEditor;

public class CopyAction extends Action {
	private DataFormat format;

	protected void setFormat(DataFormat format) {
		this.format = format;
	}

	@Override
	public Command run() throws Exception {
		CassavaGrid grid = getCassavaGrid();
		if (grid.isEditing()) {
			TableCellEditor cellEditor = grid.getCellEditor();
			if (cellEditor instanceof CassavaTableCellEditor) {
				JTextArea textArea = ((CassavaTableCellEditor) cellEditor)
						.getTextArea();
				textArea.copy();
			}
			return null;
		} else {
			if (format == null) {
				format = getTableModel().getDataFormat();
			}
			return new CopyCommand(grid.getTableModel(), grid.getViewModel()
					.getSelection(), format, Type.COPY);
		}
	}
}
