package net.asukaze.cassava.ui.action;

import net.asukaze.cassava.core.command.Command;
import net.asukaze.cassava.core.model.ICassavaTableModel;
import net.asukaze.cassava.core.model.Selection;
import net.asukaze.cassava.core.util.ValueUtil;
import net.asukaze.cassava.io.util.ClipboardUtil;

public class CopySumAction extends Action {
	@Override
	public Command run() throws Exception {
		ICassavaTableModel tableModel = getTableModel();
		Selection selection = getViewModel().getSelection();
		double sum = 0;
		for (int y = selection.top; y <= selection.bottom; y++) {
			for (int x = selection.left; x <= selection.right; x++) {
				String value = tableModel.getCalculatedValueAt(y, x);
				if (ValueUtil.isNumber(value)) {
					sum += Double.parseDouble(value);
				}
			}
		}
		String value = ValueUtil.toString(sum);
		ClipboardUtil.copy(value);
		return null;
	}
}
