package net.asukaze.cassava.ui.action;

import javax.swing.JTextArea;
import javax.swing.table.TableCellEditor;

import net.asukaze.cassava.core.command.Command;
import net.asukaze.cassava.core.model.ICassavaViewModel;
import net.asukaze.cassava.ui.table.CassavaTableCellEditor;

public class NewLineAction extends Action {
	public static final String LINE_SEPARATOR = "\n"; //$NON-NLS-1$

	@Override
	public Command run() throws Exception {
		TableCellEditor cellEditor = getCassavaGrid().getCellEditor();
		if (cellEditor instanceof CassavaTableCellEditor) {
			// eLXgGA̕ \n ǉ
			JTextArea textArea = ((CassavaTableCellEditor) cellEditor)
					.getTextArea();
			String text = textArea.getText();
			int selStart = textArea.getSelectionStart();
			int selEnd = textArea.getSelectionEnd();
			textArea.setText(text.substring(0, selStart) + LINE_SEPARATOR
					+ text.substring(selEnd));
			textArea.select(selStart + 1, selStart + 1);

			// s̍𒲐
			int rowIndex = getCassavaGrid().getEditingRow();
			ICassavaViewModel viewModel = getCassavaGrid().getViewModel();
			int curHeight = viewModel.getRowHeight(rowIndex);
			int newHeight = (int) (getCassavaGrid().getStringBounds(
					textArea.getText()).getHeight()) + 4;
			if (curHeight < newHeight) {
				viewModel.setRowHeight(rowIndex, newHeight);
			}
		}
		return null;
	}
}
