package net.asukaze.cassava.ui.action;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ButtonGroup;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JRadioButtonMenuItem;

import net.asukaze.cassava.core.command.Command;
import net.asukaze.cassava.ui.IApplication;
import net.asukaze.cassava.ui.Messages;
import net.asukaze.cassava.ui.dialog.PasteDialog.Option;

public class PasteOptionAction extends Action {
	private ButtonGroup group;

	private JRadioButtonMenuItem createRadioButtonMenuItem(String text,
			boolean selected, final String value) {
		final IApplication application = getApplication();
		JRadioButtonMenuItem item = new JRadioButtonMenuItem(text, selected);
		item.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				application.getProperties().setProperty("Paste", value); //$NON-NLS-1$
			}
		});
		group.add(item);
		return item;
	}

	@Override
	public JMenuItem createMenuItem() {
		this.group = new ButtonGroup();
		JMenu menu = new JMenu();
		menu.add(createRadioButtonMenuItem(Messages
				.getString(Messages.PASTE_OPTION_NORMAL), true, "-1"));
		menu.addSeparator();
		for (Option option : Option.getAll()) {
			menu.add(createRadioButtonMenuItem(option.toString(), false,
					Integer.toString(option.getId())));
		}
		return menu;
	}

	@Override
	public Command run() throws Exception {
		return null;
	}
}
