package net.asukaze.cassava.ui.action;

import java.awt.geom.Rectangle2D;
import java.util.ArrayList;
import java.util.List;

import net.asukaze.cassava.core.command.Command;
import net.asukaze.cassava.core.model.ICassavaTableModel;
import net.asukaze.cassava.core.model.ICassavaViewModel;
import net.asukaze.cassava.ui.table.CassavaGrid;

public class RefreshAction extends Action {
	public RefreshAction() {
		setHideEditor(true);
	}

	public static void execute(CassavaGrid grid) {
		ICassavaTableModel model = grid.getTableModel();
		List<Integer> colWidths = new ArrayList<Integer>(model.getColumnCount());
		List<Integer> rowHeights = new ArrayList<Integer>(model.getRowCount());
		for (int x = 0; x < model.getColumnCount(); x++) {
			colWidths.add(1);
		}
		for (int y = 0; y < model.getRowCount(); y++) {
			rowHeights.add(1);
		}
		for (int y = 0; y < model.getRowCount(); y++) { // TODO: \͈݂͂̂\
			for (int x = 0; x < model.getColumnCount(); x++) {
				Rectangle2D rect = grid.getStringBounds(model.getValueAt(y, x));
				int w = (int) rect.getWidth() + 4;
				colWidths.set(x, Math.max(colWidths.get(x), w));
				int h = (int) rect.getHeight() + 4;
				rowHeights.set(y, Math.max(rowHeights.get(y), h));
			}
		}

		ICassavaViewModel viewModel = grid.getViewModel();
		viewModel.setColWidths(colWidths);
		viewModel.setRowHeights(rowHeights);
	}

	@Override
	public Command run() {
		execute(getCassavaGrid());
		return null;
	}
}
