package net.asukaze.cassava.ui.action;

import java.awt.Frame;
import java.io.IOException;
import java.io.PipedInputStream;
import java.io.PipedOutputStream;

import net.asukaze.cassava.core.command.Command;
import net.asukaze.cassava.core.model.ICassavaTableModel;
import net.asukaze.cassava.io.command.SaveFileThread;
import net.asukaze.cassava.io.util.HybridFileDialog;
import net.asukaze.cassava.ui.Messages;

public class SaveAsAction extends Action {
	public SaveAsAction() {
		setHideEditor(true);
	}

	public static void execute(Frame frame, ICassavaTableModel model)
			throws IOException {
		PipedInputStream pis = new PipedInputStream();
		PipedOutputStream pos = new PipedOutputStream(pis);
		String defaultFilename = model.getFilename();
		if (defaultFilename == null) {
			defaultFilename = Messages.getString(Messages.SAVE_DIALOG_DEFAULT);
		}

		Thread thread = new Thread(new SaveFileThread(model, pos, null));
		thread.start();
		String filename = HybridFileDialog.saveFile(frame, Messages
				.getString(Messages.SAVE_DIALOG_TITLE), pis, defaultFilename);
		if (filename != null) {
			model.setFilename(filename);
		}
	}

	@Override
	public Command run() throws Exception {
		execute(getFrame(), getTableModel());
		return null;
	}
}
