package net.asukaze.cassava.ui.action;

import net.asukaze.cassava.core.command.Command;
import net.asukaze.cassava.core.model.ICassavaTableModel;
import net.asukaze.cassava.ui.command.SortCommand;
import net.asukaze.cassava.ui.dialog.SortListener;
import net.asukaze.cassava.ui.dialog.SortDialog;

public class SortAction extends Action {
	private static class Listener implements SortListener {
		public Command command = null;
		private ICassavaTableModel model;

		public Listener(ICassavaTableModel model) {
			this.model = model;
		}

		@Override
		public void sort(int left, int top, int right, int bottom, int key,
				boolean orderByDesc, boolean number) {
			command = new SortCommand(model, left, top, right, bottom, key,
					orderByDesc, number);
		}
	}

	public SortAction() {
		setHideEditor(true);
	}

	@Override
	public Command run() throws Exception {
		Listener listener = new Listener(getTableModel());
		SortDialog dialog = new SortDialog(getFrame(), true, getTableModel(),
				getViewModel(), listener);
		dialog.setVisible(true);
		return listener.command;
	}
}
