package net.asukaze.cassava.ui.action;

import javax.swing.JTextArea;
import javax.swing.table.TableCellEditor;

import net.asukaze.cassava.core.command.Command;
import net.asukaze.cassava.core.model.ICassavaViewModel;
import net.asukaze.cassava.ui.command.SplitRowCommand;
import net.asukaze.cassava.ui.table.CassavaGrid;
import net.asukaze.cassava.ui.table.CassavaTableCellEditor;

public class SplitRowAction extends Action {
	private int rowIndex;
	private int selLength;

	@Override
	public Command run() throws Exception {
		ICassavaViewModel viewModel = getViewModel();
		CassavaGrid grid = getCassavaGrid();
		int selStart = 0;
		rowIndex = viewModel.getCurrentRow();
		selLength = -1;
		if (grid.isEditing()) {
			TableCellEditor cellEditor = getCassavaGrid().getCellEditor();
			if (cellEditor instanceof CassavaTableCellEditor) {
				JTextArea textArea = ((CassavaTableCellEditor) cellEditor)
						.getTextArea();
				selStart = textArea.getSelectionStart();
				selLength = textArea.getSelectionEnd() - selStart;
			}
			cellEditor.stopCellEditing();
		}
		return new SplitRowCommand(getTableModel(), rowIndex, viewModel
				.getCurrentCol(), selStart);
	}

	public void afterFirstRun() {
		CassavaGrid grid = getCassavaGrid();
		if (selLength >= 0) {
			grid.editCellAt(rowIndex + 1, 0);
			TableCellEditor cellEditor = grid.getCellEditor();
			if (cellEditor instanceof CassavaTableCellEditor) {
				JTextArea textArea = ((CassavaTableCellEditor) cellEditor)
						.getTextArea();
				textArea.setSelectionStart(0);
				textArea.setSelectionEnd(selLength);
			}
		}
	}
}
