package net.asukaze.cassava.ui.command;

import net.asukaze.cassava.core.command.Command;
import net.asukaze.cassava.core.command.CommandException;
import net.asukaze.cassava.core.model.ICassavaTableModel;
import net.asukaze.cassava.core.model.Selection;
import net.asukaze.cassava.core.util.ModelUtil;

public class ConnectCellCommand implements Command {
	private ICassavaTableModel model;
	private Selection selection;
	private ICassavaTableModel old;

	public ConnectCellCommand(ICassavaTableModel model, Selection selection) {
		this.model = model;
		this.selection = selection;
	}

	@Override
	public boolean canUndo() {
		return true;
	}

	@Override
	public Status run() throws CommandException {
		old = ModelUtil.cut(model, selection);
		StringBuilder sb = new StringBuilder();
		for (int y = 0; y < old.getRowCount(); y++) {
			for (int x = 0; x < old.getColumnCount(); x++) {
				sb.append(old.getValueAt(y, x));
			}
		}
		model.setValueAt(sb.toString(), selection.top, selection.left);
		return CHANGED;
	}

	@Override
	public Status undo() throws CommandException {
		ModelUtil.paste(model, selection, old);
		old = null;
		return CHANGED;
	}
}
