package net.asukaze.cassava.ui.dialog;

import javax.swing.JOptionPane;

import net.asukaze.cassava.io.command.PasteCommand.Behavior;
import net.asukaze.cassava.ui.Messages;

public class PasteDialog {
	public static class Option {
		public static final Option OVERRAPPED = new Option(0,
				Behavior.OVERRAPPED);
		public static final Option REPEAT = new Option(1, Behavior.REPEAT);
		public static final Option DATASIZE = new Option(2, Behavior.DATASIZE);
		public static final Option MOVERIGHT = new Option(3, Behavior.MOVERIGHT);
		public static final Option MOVEDOWN = new Option(4, Behavior.MOVEDOWN);
		public static final Option ONECELL = new Option(5, null);

		private int id;
		private Behavior behavior;
		private String string;

		private Option(int id, Behavior behavior) {
			this.id = id;
			this.behavior = behavior;
			this.string = Messages.getString(Messages.PASTE_DIALOG_OPTION_N
					+ id);
		}

		public int getId() {
			return id;
		}

		@Override
		public String toString() {
			return string;
		}

		public Behavior toBehavior() {
			return behavior;
		}

		public static Option[] getAll() {
			return new Option[] { OVERRAPPED, REPEAT, DATASIZE, MOVERIGHT,
					MOVEDOWN, ONECELL };
		}
	}

	public static final PasteDialog INSTANCE = new PasteDialog();

	private Option lastSelected = null;

	public Option show(int selectedColumns, int selectedRows, int clipColumns,
			int clipRows) {
		if (lastSelected == null) {
			lastSelected = Option.DATASIZE;
		}
		String message = Messages.getString(Messages.PASTE_DIALOG_MESSAGE,
				selectedColumns, selectedRows, clipColumns, clipRows);
		String title = Messages.getString(Messages.OPTION_DIALOG_TITLE);
		Object selectedValue = JOptionPane.showInputDialog(null, message,
				title, JOptionPane.QUESTION_MESSAGE, null, Option.getAll(),
				lastSelected);
		if (selectedValue instanceof Option) {
			lastSelected = (Option) selectedValue;
			return lastSelected;
		} else {
			return null;
		}
	}
}
