package net.asukaze.cassava.ui.table;

import java.awt.Color;
import java.awt.Component;

import javax.swing.BorderFactory;
import javax.swing.DefaultListModel;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JTable;
import javax.swing.ListCellRenderer;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableModel;

/**
 * JScrollPane  RowHeaderView ɃZbg邱ƂŁAswb_\܂B<br>
 * Ql: http://terai.xrea.jp/Swing/TableRowHeader.html
 */
@SuppressWarnings("serial")
public class CassavaRowHeaderList extends JList<String> {
	public CassavaRowHeaderList(JTable table) {
		super();
		setModel(new TableListModel(table.getModel()));
		setFixedCellHeight(table.getRowHeight());
		setFixedCellWidth(50);
		setCellRenderer(new RowHeaderRenderer(table.getTableHeader()));
	}

	private static class TableListModel extends DefaultListModel<String> {
		private TableModel tableModel;

		public TableListModel(TableModel tableModel) {
			this.tableModel = tableModel;
		}

		@Override
		public String getElementAt(int index) {
			return Integer.toString(index + 1);
		}

		@Override
		public int getSize() {
			return tableModel.getRowCount();
		}
	}

	private static class RowHeaderRenderer extends JLabel
			implements ListCellRenderer<String> {
		private JTableHeader header;

		public RowHeaderRenderer(JTableHeader header) {
			this.header = header;
			this.setOpaque(true);
			this.setBorder(
					BorderFactory.createMatteBorder(0, 0, 1, 1, Color.GRAY));
			this.setHorizontalAlignment(CENTER);
			this.setFont(header.getFont());
		}

		public Component getListCellRendererComponent(
				JList<? extends String> list, String value, int index,
				boolean isSelected, boolean cellHasFocus) {
			setForeground(header.getForeground());
			setBackground(header.getBackground());
			setText((value == null) ? "" : value.toString());
			return this;
		}
	}
}
