package net.asukaze.cassava.ui.table;

import java.util.ArrayList;
import java.util.List;

import javax.swing.RowSorter;
import javax.swing.table.TableModel;

import net.asukaze.cassava.core.model.ICassavaViewModel;

public class CassavaTableRowSorter extends RowSorter<TableModel> {
	private TableModel tableModel;
	private ICassavaViewModel viewModel;

	public CassavaTableRowSorter(TableModel tableModel,
			ICassavaViewModel viewModel) {
		this.tableModel = tableModel;
		this.viewModel = viewModel;
	}

	@Override
	public void allRowsChanged() {
	}

	@Override
	public int convertRowIndexToModel(int index) {
		return index + viewModel.getFixRowCount();
	}

	@Override
	public int convertRowIndexToView(int index) {
		return index - viewModel.getFixRowCount();
	}

	@Override
	public TableModel getModel() {
		return tableModel;
	}

	@Override
	public int getModelRowCount() {
		return tableModel.getRowCount();
	}

	@Override
	public List<? extends SortKey> getSortKeys() {
		return new ArrayList<SortKey>();
	}

	@Override
	public int getViewRowCount() {
		return tableModel.getRowCount() - viewModel.getFixRowCount();
	}

	@Override
	public void modelStructureChanged() {
	}

	@Override
	public void rowsDeleted(int firstRow, int endRow) {
	}

	@Override
	public void rowsInserted(int firstRow, int endRow) {
	}

	@Override
	public void rowsUpdated(int firstRow, int endRow) {
	}

	@Override
	public void rowsUpdated(int firstRow, int endRow, int column) {
	}

	@Override
	public void setSortKeys(List<? extends SortKey> keys) {
		// TODO Auto-generated method stub
	}

	@Override
	public void toggleSortOrder(int column) {
		// TODO Auto-generated method stub
	}
}
