package net.asukaze.cassava.ui.action;

import static org.junit.Assert.*;

import net.asukaze.cassava.core.model.ICassavaTableModel;
import net.asukaze.cassava.core.model.ICassavaViewModel;
import net.asukaze.cassava.ui.MainFrame;
import net.asukaze.cassava.ui.table.CassavaGrid;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

public class InsertRowActionTest {
	private MainFrame frame;

	@Before
	public void setUp() {
		frame = new MainFrame();
		frame.setVisible(true);
		frame.getCassavaGrid();
	}

	@After
	public void tearDown() {
		frame.setVisible(false);
		frame.dispose();
	}

	@Test
	public void testRun() throws Exception {
		CassavaGrid grid = frame.getCassavaGrid();
		ICassavaTableModel model = grid.getTableModel();
		ICassavaViewModel viewModel = grid.getViewModel();
		model.setValueAt("AAA", 0, 1); //$NON-NLS-1$
		model.setValueAt("BBB", 1, 1); //$NON-NLS-1$
		model.setValueAt("CCC", 2, 1); //$NON-NLS-1$
		Thread.sleep(1000);
		viewModel.setCurrentRowCol(1, 1);
		grid.updateUI();
		InsertRowAction insertRowAction = new InsertRowAction();
		insertRowAction.setApplication(frame);
		insertRowAction.actionPerformed(null);
		Thread.sleep(1000);
		assertEquals("AAA", model.getValueAt(0, 1)); //$NON-NLS-1$
		assertEquals("", model.getValueAt(1, 1)); //$NON-NLS-1$
		assertEquals("BBB", model.getValueAt(2, 1)); //$NON-NLS-1$
		assertEquals("CCC", model.getValueAt(3, 1)); //$NON-NLS-1$
		assertEquals("", model.getValueAt(4, 1)); //$NON-NLS-1$
		UndoAction undoAction = new UndoAction();
		undoAction.setApplication(frame);
		undoAction.actionPerformed(null);
		Thread.sleep(1000);
		assertEquals("AAA", model.getValueAt(0, 1)); //$NON-NLS-1$
		assertEquals("BBB", model.getValueAt(1, 1)); //$NON-NLS-1$
		assertEquals("CCC", model.getValueAt(2, 1)); //$NON-NLS-1$
		assertEquals("", model.getValueAt(3, 1)); //$NON-NLS-1$
		assertEquals("", model.getValueAt(4, 1)); //$NON-NLS-1$
	}
}
