package net.asukaze.cassava.macro.action;

import net.asukaze.cassava.core.command.Command;
import net.asukaze.cassava.io.util.FileInfo;
import net.asukaze.cassava.io.util.HybridFileDialog;
import net.asukaze.cassava.macro.Macro;
import net.asukaze.cassava.macro.Messages;
import net.asukaze.cassava.macro.api.GUIMessageBoxFunctionHandler;
import net.asukaze.cassava.macro.api.TableWriteFunctionHandler;
import net.asukaze.cassava.ui.IApplication;
import net.asukaze.cassava.ui.action.Action;
import net.asukaze.cassava.ui.table.CassavaGrid;

public class MacroExecuteAction extends Action {
	public MacroExecuteAction() {
		setHideEditor(true);
	}

	public static Macro setupMacro(IApplication app) {
		Macro macro = new Macro();
		CassavaGrid grid = app.getCassavaGrid();
		macro.setModel(grid.getTableModel());
		macro.setViewModel(grid.getViewModel());
		macro.registerAPIFunctionHandler(new TableWriteFunctionHandler());
		macro.registerAPIFunctionHandler(new GUIMessageBoxFunctionHandler(app
				.getFrame()));
		macro.registerAPIFunctionHandler(new ActionFunctionHandler(app));
		return macro;
	}

	@Override
	public Command run() throws Exception {
		FileInfo fileinfo = HybridFileDialog.openFile(getFrame(), Messages
				.getString(Messages.MACRO_EXEC_DIALOG_TITLE));
		if (fileinfo != null && fileinfo.getInputStream() != null) {
			Macro macro = setupMacro(getApplication());
			macro.run(fileinfo.getInputStream());
		}
		return null;
	}
}
