package net.asukaze.cassava.macro.api;

import java.io.IOException;

import net.asukaze.cassava.core.model.ICassavaViewModel;
import net.asukaze.cassava.macro.APIFunctionHandler;
import net.asukaze.cassava.macro.Environment;
import net.asukaze.cassava.macro.FunctionNotFoundException;
import net.asukaze.cassava.macro.Macro;

public class TableWriteFunctionHandler implements APIFunctionHandler {
	public Object runAPIFunction(String name, Object[] args, Macro macro)
			throws IOException {
		int n = args.length;
		if ("write".equals(name)) { //$NON-NLS-1$
			write(args, macro);
			return null;
		} else if ("writeln".equals(name)) { //$NON-NLS-1$
			writeln(args, macro);
			return null;
		}
		return new FunctionNotFoundException(name, n);
	}

	private void write(Object[] args, Macro macro) {
		Environment environment = macro.getEnvironment();
		ICassavaViewModel viewModel = environment.getViewModel();
		int y = viewModel.getCurrentRow();
		int x = viewModel.getCurrentCol();
		for (int i = 0; i < args.length; i++) {
			String text = macro.toString(args[i]);
			environment.setValueAt0(text, y - 1, x + i - 1);
		}
		viewModel.setCurrentCol(x + args.length);
	}

	private void writeln(Object[] args, Macro macro) {
		write(args, macro);
		ICassavaViewModel viewModel = macro.getEnvironment().getViewModel();
		int y = viewModel.getCurrentRow();
		viewModel.setCurrentRowCol(y + 1, 1);
	}

	public void close() {
	}
}
