package net.asukaze.cassava.macro.cui;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.PrintStream;

import net.asukaze.cassava.core.model.ICassavaTableModel;
import net.asukaze.cassava.macro.APIFunctionHandler;
import net.asukaze.cassava.macro.FunctionNotFoundException;
import net.asukaze.cassava.macro.Macro;

public class MenuEmulator implements APIFunctionHandler {
	private BufferedReader in;
	private PrintStream out;

	public MenuEmulator(BufferedReader in, PrintStream out) {
		this.in = in;
		this.out = out;
	}

	public MenuEmulator() {
		this.in = null;
		this.out = null;
	}

	public Object runAPIFunction(String name, Object[] args, Macro macro)
			throws IOException {
		if (args.length != 0) {
			return new FunctionNotFoundException(name, args.length);
		}
		if ("New".equals(name)) { //$NON-NLS-1$
			ICassavaTableModel model = macro.getEnvironment().getModel();
			if (InteractiveFunctionHandler.confirmIfModified(model,
					"e[u܂H", in, out)) {
				model.clear();
			}
			return null;
		} else if ("Refresh".equals(name)) { //$NON-NLS-1$
			return null;
		}
		return new FunctionNotFoundException(name, args.length);
	}

	public void close() {
	}
}
